//  File Edited by Edward Burbank
//  DildoFox 2023/24

/*
import { MigrationWizardConstants } from "chrome://browser/content/migration/migration-wizard-constants.mjs";
*/

/*
import { XPCOMUtils } from "resource://gre/modules/XPCOMUtils.sys.mjs";
*/

//const lazy = {};

/*
XPCOMUtils.defineLazyPreferenceGetter(
  lazy,
  "SHOW_IMPORT_ALL_PREF",
  "browser.migrate.content-modal.import-all.enabled",
  false
);
*/

/*
export class MigrationWizardChild extends JSWindowActorChild {
  
  /*
  #wizardEl = null;

  /*
   * @param {Event} event
   * @returns {Promise}
   */

  /*
  async handleEvent(event) {
    switch (event.type) {
      case "MigrationWizard:RequestState": {
        this.#sendTelemetryEvent("opened");

        this.#wizardEl = event.target;
        this.setComponentState({
          page: MigrationWizardConstants.PAGES.LOADING,
        });

        let migrators = await this.sendQuery("GetAvailableMigrators");
        let hasBrowserMigrators = migrators.some(migrator => {
          return (
            migrator.type == MigrationWizardConstants.MIGRATOR_TYPES.BROWSER
          );
        });
        let hasFileMigrators = migrators.some(migrator => {
          return migrator.type == MigrationWizardConstants.MIGRATOR_TYPES.FILE;
        });
        if (!hasBrowserMigrators && !event.detail?.allowOnlyFileMigrators) {
          this.setComponentState({
            page: MigrationWizardConstants.PAGES.NO_BROWSERS_FOUND,
            hasFileMigrators,
          });
          this.#sendTelemetryEvent("no_browsers_found");
        } else {
          this.setComponentState({
            migrators,
            page: MigrationWizardConstants.PAGES.SELECTION,
            showImportAll: lazy.SHOW_IMPORT_ALL_PREF,
          });
        }

        this.#wizardEl.dispatchEvent(
          new this.contentWindow.CustomEvent("MigrationWizard:Ready", {
            bubbles: true,
          })
        );
        break;
      }

      case "MigrationWizard:BeginMigration": {
        let extraArgs = this.#recordBeginMigrationEvent(event.detail);

        let hasPermissions = await this.sendQuery("CheckPermissions", {
          key: event.detail.key,
          type: event.detail.type,
        });

        if (!hasPermissions) {
          if (event.detail.key == "safari") {
            this.#sendTelemetryEvent("safari_perms");
            this.setComponentState({
              page: MigrationWizardConstants.PAGES.SAFARI_PERMISSION,
            });
          } else {
            console.error(
              `A migrator with key ${event.detail.key} needs permissions, ` +
                "and no UI exists for that right now."
            );
          }
          return;
        }

        await this.beginMigration(event.detail, extraArgs);
        break;
      }

      case "MigrationWizard:RequestSafariPermissions": {
        let success = await this.sendQuery("RequestSafariPermissions");
        if (success) {
          let extraArgs = this.#constructExtraArgs(event.detail);
          await this.beginMigration(event.detail, extraArgs);
        }
        break;
      }

      case "MigrationWizard:SelectSafariPasswordFile": {
        let path = await this.sendQuery("SelectSafariPasswordFile");
        if (path) {
          event.detail.safariPasswordFilePath = path;

          let passwordResourceIndex = event.detail.resourceTypes.indexOf(
            MigrationWizardConstants.DISPLAYED_RESOURCE_TYPES.PASSWORDS
          );
          event.detail.resourceTypes.splice(passwordResourceIndex, 1);

          let extraArgs = this.#constructExtraArgs(event.detail);
          await this.beginMigration(event.detail, extraArgs);
        }
        break;
      }
    }
  }
  */

  /*
   * @param {string} type
   * @param {object} [args=null]
   */

  /*
  #sendTelemetryEvent(type, args) {
    this.sendAsyncMessage("RecordEvent", { type, args });
  }
  */

  /*
   * @param {object} migrationDetails
   * @returns {object}
   */
 
  /*
  #constructExtraArgs(migrationDetails) {
    let extraArgs = {
      migrator_key: migrationDetails.key,
      history: "0",
      formdata: "0",
      passwords: "0",
      bookmarks: "0",
      payment_methods: "0",
      other: 0,
    };

    for (let type of migrationDetails.resourceTypes) {
      switch (type) {
        case MigrationWizardConstants.DISPLAYED_RESOURCE_TYPES.HISTORY: {
          extraArgs.history = "1";
          break;
        }

        case MigrationWizardConstants.DISPLAYED_RESOURCE_TYPES.FORMDATA: {
          extraArgs.formdata = "1";
          break;
        }

        case MigrationWizardConstants.DISPLAYED_RESOURCE_TYPES.PASSWORDS: {
          extraArgs.passwords = "1";
          break;
        }

        case MigrationWizardConstants.DISPLAYED_RESOURCE_TYPES.BOOKMARKS: {
          extraArgs.bookmarks = "1";
          break;
        }

        case MigrationWizardConstants.DISPLAYED_RESOURCE_TYPES
          .PAYMENT_METHODS: {
          extraArgs.payment_methods = "1";
          break;
        }

        default: {
          extraArgs.other++;
        }
      }
    }

    extraArgs.other = String(extraArgs.other);
    return extraArgs;
  }
  */

  /*
   * @param {object} migrationDetails
   * @returns {object}
   */

  /*
  #recordBeginMigrationEvent(migrationDetails) {
    this.#sendTelemetryEvent("browser_selected", {
      migrator_key: migrationDetails.key,
    });

    if (migrationDetails.profile) {
      this.#sendTelemetryEvent("profile_selected", {
        migrator_key: migrationDetails.key,
      });
    }

    let extraArgs = this.#constructExtraArgs(migrationDetails);

    extraArgs.configured = String(Number(migrationDetails.expandedDetails));
    this.#sendTelemetryEvent("resources_selected", extraArgs);
    delete extraArgs.configured;

    this.#sendTelemetryEvent("migration_started", extraArgs);
    return extraArgs;
  }
  */

  /*
   * @param {object} migrationDetails
   * @param {object} extraArgs
   * @returns {Promise<undefined>}
   */
  
  /*
  async beginMigration(migrationDetails, extraArgs) {
    if (
      migrationDetails.key == "safari" &&
      migrationDetails.resourceTypes.includes(
        MigrationWizardConstants.DISPLAYED_RESOURCE_TYPES.PASSWORDS
      ) &&
      !migrationDetails.safariPasswordFilePath
    ) {
      this.#sendTelemetryEvent("safari_password_file");
      this.setComponentState({
        page: MigrationWizardConstants.PAGES.SAFARI_PASSWORD_PERMISSION,
      });
      return;
    }

    await this.sendQuery("Migrate", migrationDetails);
    this.#sendTelemetryEvent("migration_finished", extraArgs);

    this.#wizardEl.dispatchEvent(
      new this.contentWindow.CustomEvent("MigrationWizard:DoneMigration", {
        bubbles: true,
      })
    );
  }
  */

  /*
   * @param {ReceiveMessageArgument} message
   */
  
  /*
  receiveMessage(message) {
    switch (message.name) {
      case "UpdateProgress": {
        this.setComponentState({
          page: MigrationWizardConstants.PAGES.PROGRESS,
          progress: message.data.progress,
          key: message.data.key,
        });
        break;
      }
      case "UpdateFileImportProgress": {
        this.setComponentState({
          page: MigrationWizardConstants.PAGES.FILE_IMPORT_PROGRESS,
          progress: message.data.progress,
          title: message.data.title,
        });
        break;
      }
    }
  }
  */

  /*
   * @param {object} state 
   */

  /*
  setComponentState(state) {
    if (!this.#wizardEl) {
      return;
    }
    Cu.waiveXrays(this.#wizardEl).setState(
      Cu.cloneInto(
        state,
        this.#wizardEl.ownerDocument.defaultView
      )
    );
  }
}
*/
