//  File Edited by Edward Burbank
//  DildoFox 2023/24

/* 
import { AppConstants } from "resource://gre/modules/AppConstants.sys.mjs";
import { MigrationUtils } from "resource:///modules/MigrationUtils.sys.mjs";
import { E10SUtils } from "resource://gre/modules/E10SUtils.sys.mjs";
import { XPCOMUtils } from "resource://gre/modules/XPCOMUtils.sys.mjs";
*/

//const lazy = {};

/*
XPCOMUtils.defineLazyGetter(lazy, "gFluentStrings", function () {
  return new Localization([
    "branding/brand.ftl",
    "browser/migrationWizard.ftl",
  ]);
});

ChromeUtils.defineESModuleGetters(lazy, {
  InternalTestingProfileMigrator:
    "resource:///modules/InternalTestingProfileMigrator.sys.mjs",
  MigrationWizardConstants:
    "chrome://browser/content/migration/migration-wizard-constants.mjs",
  PasswordFileMigrator: "resource:///modules/FileMigrators.sys.mjs",
});

if (AppConstants.platform == "macosx") {
  ChromeUtils.defineESModuleGetters(lazy, {
    SafariProfileMigrator: "resource:///modules/SafariProfileMigrator.sys.mjs",
  });
}

XPCOMUtils.defineLazyModuleGetters(lazy, {
  LoginCSVImport: "resource://gre/modules/LoginCSVImport.jsm",
});
*/

/*
export class MigrationWizardParent extends JSWindowActorParent {
  
  /*
  constructor() {
    super();
    Services.telemetry.setEventRecordingEnabled("browser.migration", true);
  }

  didDestroy() {
    Services.obs.notifyObservers(this, "MigrationWizard:Destroyed");
  }
  */

  /*
   * @param {ReceiveMessageArgument} message
   * @returns {Promise}
   */

  /*
  async receiveMessage(message) {
    if (
      !this.browsingContext.currentWindowGlobal.isInProcess &&
      this.browsingContext.currentRemoteType !=
        E10SUtils.PRIVILEGEDABOUT_REMOTE_TYPE
    ) {
      throw new Error(
        "MigrationWizardParent: received message from the wrong content process type."
      );
    }

    switch (message.name) {
      case "GetAvailableMigrators": {
        let availableMigrators = [];
        for (const key of MigrationUtils.availableMigratorKeys) {
          availableMigrators.push(this.#getMigratorAndProfiles(key));
        }

        let results = await Promise.all(availableMigrators);

        for (const migrator of MigrationUtils.availableFileMigrators.values()) {
          results.push(await this.#serializeFileMigrator(migrator));
        }

        let filteredResults = results
          .flat()
          .filter(result => result)
          .sort((a, b) => {
            return b.lastModifiedDate - a.lastModifiedDate;
          });

        for (let result of filteredResults) {
          Services.telemetry.keyedScalarAdd(
            "migration.discovered_migrators",
            result.key,
            1
          );
        }
        return filteredResults;
      }

      case "Migrate": {
        if (
          message.data.type ==
          lazy.MigrationWizardConstants.MIGRATOR_TYPES.BROWSER
        ) {
          await this.#doBrowserMigration(
            message.data.key,
            message.data.resourceTypes,
            message.data.profile,
            message.data.safariPasswordFilePath
          );
        } else if (
          message.data.type == lazy.MigrationWizardConstants.MIGRATOR_TYPES.FILE
        ) {
          let window = this.browsingContext.topChromeWindow;
          await this.#doFileMigration(window, message.data.key);
        }
        break;
      }

      case "CheckPermissions": {
        if (
          message.data.type ==
          lazy.MigrationWizardConstants.MIGRATOR_TYPES.BROWSER
        ) {
          let migrator = await MigrationUtils.getMigrator(message.data.key);
          return migrator.hasPermissions();
        }
        return true;
      }

      case "RequestSafariPermissions": {
        let safariMigrator = await MigrationUtils.getMigrator("safari");
        return safariMigrator.getPermissions(
          this.browsingContext.topChromeWindow
        );
      }

      case "SelectSafariPasswordFile": {
        return this.#selectSafariPasswordFile(
          this.browsingContext.topChromeWindow
        );
      }

      case "RecordEvent": {
        this.#recordEvent(message.data.type, message.data.args);
        break;
      }
    }

    return null;
  }
  */

  /*
   * @param {string} type
   * @param {object} args
   */

  /*
  #recordEvent(type, args = null) {
    Services.telemetry.recordEvent(
      "browser.migration",
      type,
      "wizard",
      null,
      args
    );
  }
  */

  /*
   * @param {DOMWindow} window
   * @param {string} key
   * @returns {Promise<undefined>}
   */

  /*
  async #doFileMigration(window, key) {
    let fileMigrator = MigrationUtils.getFileMigrator(key);
    let filePickerConfig = await fileMigrator.getFilePickerConfig();

    let { result, path } = await new Promise(resolve => {
      let fp = Cc["@mozilla.org/filepicker;1"].createInstance(Ci.nsIFilePicker);
      fp.init(window, filePickerConfig.title, Ci.nsIFilePicker.modeOpen);

      for (let filter of filePickerConfig.filters) {
        fp.appendFilter(filter.title, filter.extensionPattern);
      }
      fp.appendFilters(Ci.nsIFilePicker.filterAll);
      fp.open(async fileOpenResult => {
        resolve({ result: fileOpenResult, path: fp.file.path });
      });
    });

    if (result == Ci.nsIFilePicker.returnCancel) {
      return;
    }

    let progress = {};
    for (let resourceType of fileMigrator.displayedResourceTypes) {
      progress[resourceType] = {
        inProgress: true,
        message: "",
      };
    }

    let [progressHeaderString, successHeaderString] =
      await lazy.gFluentStrings.formatValues([
        fileMigrator.progressHeaderL10nID,
        fileMigrator.successHeaderL10nID,
      ]);

    this.sendAsyncMessage("UpdateFileImportProgress", {
      title: progressHeaderString,
      progress,
    });
    let migrationResult = await fileMigrator.migrate(path);
    let successProgress = {};
    for (let resourceType in migrationResult) {
      successProgress[resourceType] = {
        inProgress: false,
        message: migrationResult[resourceType],
      };
    }
    this.sendAsyncMessage("UpdateFileImportProgress", {
      title: successHeaderString,
      progress: successProgress,
    });
  }
  */

  /*
   * @param {DOMWindow} window
   * @returns {Promise<string|null>}
   */

  /*
  async #selectSafariPasswordFile(window) {
    let fileMigrator = MigrationUtils.getFileMigrator(
      lazy.PasswordFileMigrator.key
    );
    let filePickerConfig = await fileMigrator.getFilePickerConfig();

    let { result, path } = await new Promise(resolve => {
      let fp = Cc["@mozilla.org/filepicker;1"].createInstance(Ci.nsIFilePicker);
      fp.init(window, filePickerConfig.title, Ci.nsIFilePicker.modeOpen);

      for (let filter of filePickerConfig.filters) {
        fp.appendFilter(filter.title, filter.extensionPattern);
      }
      fp.appendFilters(Ci.nsIFilePicker.filterAll);
      fp.open(async fileOpenResult => {
        resolve({ result: fileOpenResult, path: fp.file.path });
      });
    });

    if (result == Ci.nsIFilePicker.returnCancel) {
      return null;
    }

    return path;
  }
  */

  /*
   * @param {string} migratorKey
   * @param {string[]} resourceTypeNames
   * @param {object|null} profileObj
   * @param {string} profileObj.id
   * @param {string} profileObj.name
   * @param {string} [safariPasswordFilePath=null]
   * @returns {Promise<undefined>}
   */

  /*
  async #doBrowserMigration(
    migratorKey,
    resourceTypeNames,
    profileObj,
    safariPasswordFilePath = null
  ) {
    let migrator = await MigrationUtils.getMigrator(migratorKey);
    let availableResourceTypes = await migrator.getMigrateData(profileObj);
    let resourceTypesToMigrate = 0;
    let progress = {};

    for (let resourceTypeName of resourceTypeNames) {
      let resourceType = MigrationUtils.resourceTypes[resourceTypeName];
      if (availableResourceTypes & resourceType) {
        resourceTypesToMigrate |= resourceType;
        progress[resourceTypeName] = {
          inProgress: true,
          message: "",
        };
      }
    }

    if (
      migratorKey == lazy.SafariProfileMigrator?.key &&
      safariPasswordFilePath
    ) {
      progress[
        lazy.MigrationWizardConstants.DISPLAYED_RESOURCE_TYPES.PASSWORDS
      ] = {
        inProgress: true,
        message: "",
      };

      this.sendAsyncMessage("UpdateProgress", { key: migratorKey, progress });

      let summary = await lazy.LoginCSVImport.importFromCSV(
        safariPasswordFilePath
      );
      let quantity = summary.filter(entry => entry.result == "added").length;

      progress[
        lazy.MigrationWizardConstants.DISPLAYED_RESOURCE_TYPES.PASSWORDS
      ] = {
        inProgress: false,
        message: await lazy.gFluentStrings.formatValue(
          "migration-wizard-progress-success-passwords",
          {
            quantity,
          }
        ),
      };
    }

    this.sendAsyncMessage("UpdateProgress", { key: migratorKey, progress });

    if (safariPasswordFilePath && !resourceTypeNames.length) {
      return;
    }

    try {
      await migrator.migrate(
        resourceTypesToMigrate,
        false,
        profileObj,
        async resourceTypeNum => {
          let foundResourceTypeName;
          for (let resourceTypeName in MigrationUtils.resourceTypes) {
            if (
              MigrationUtils.resourceTypes[resourceTypeName] == resourceTypeNum
            ) {
              foundResourceTypeName = resourceTypeName;
              break;
            }
          }

          if (!foundResourceTypeName) {
            console.error(
              "Could not find a resource type for value: ",
              resourceTypeNum
            );
          } else {
            progress[foundResourceTypeName] = {
              inProgress: false,
              message: await this.#getStringForImportQuantity(
                migratorKey,
                foundResourceTypeName
              ),
            };
            this.sendAsyncMessage("UpdateProgress", {
              key: migratorKey,
              progress,
            });
          }
        }
      );
    } catch (e) {
      console.error(e);
    }
  }
  */

  /*
   * @typedef {object} MigratorProfileInstance
   * @property {string} key
   * @property {string} displayName
   * @property {string[]} resourceTypes
   * @property {object|null} profile
   * @property {string} profile.id
   * @property {string} profile.name
   */

  /*
   * @param {string} key
   * @returns {Promise<MigratorProfileInstance[]|null>}
   */

  /*
  async #getMigratorAndProfiles(key) {
    try {
      let migrator = await MigrationUtils.getMigrator(key);
      if (!migrator?.enabled) {
        return null;
      }

      let sourceProfiles = await migrator.getSourceProfiles();
      if (Array.isArray(sourceProfiles)) {
        if (!sourceProfiles.length) {
          return null;
        }

        let result = [];
        for (let profile of sourceProfiles) {
          result.push(
            await this.#serializeMigratorAndProfile(migrator, profile)
          );
        }
        return result;
      }
      return this.#serializeMigratorAndProfile(migrator, sourceProfiles);
    } catch (e) {
      console.error(`Could not get migrator with key ${key}`, e);
    }
    return null;
  }
  */

  /*
   * @param {MigratorBase} migrator
   * @param {object|null} profileObj
   * @returns {Promise<MigratorProfileInstance>}
   */

  /*
  async #serializeMigratorAndProfile(migrator, profileObj) {
    let [profileMigrationData, lastModifiedDate] = await Promise.all([
      migrator.getMigrateData(profileObj),
      migrator.getLastUsedDate(),
    ]);

    let availableResourceTypes = [];

    for (let resourceType in MigrationUtils.resourceTypes) {
      if (
        profileMigrationData & MigrationUtils.resourceTypes[resourceType] ||
        (migrator.constructor.key == lazy.SafariProfileMigrator?.key &&
          MigrationUtils.resourceTypes[resourceType] ==
            MigrationUtils.resourceTypes.PASSWORDS &&
          Services.prefs.getBoolPref(
            "signon.management.page.fileImport.enabled",
            false
          ))
      ) {
        availableResourceTypes.push(resourceType);
      }
    }

    let displayName;

    if (migrator.constructor.key == lazy.InternalTestingProfileMigrator.key) {
      displayName = migrator.constructor.displayNameL10nID;
    } else {
      displayName = await lazy.gFluentStrings.formatValue(
        migrator.constructor.displayNameL10nID
      );
    }

    return {
      type: lazy.MigrationWizardConstants.MIGRATOR_TYPES.BROWSER,
      key: migrator.constructor.key,
      displayName,
      brandImage: migrator.constructor.brandImage,
      resourceTypes: availableResourceTypes,
      profile: profileObj,
      lastModifiedDate,
    };
  }
  */

  /*
   * @param {string} migratorKey
   * @param {string} resourceTypeStr
   * @returns {Promise<string>}
   */

  /*
  #getStringForImportQuantity(migratorKey, resourceTypeStr) {
    switch (resourceTypeStr) {
      case lazy.MigrationWizardConstants.DISPLAYED_RESOURCE_TYPES.BOOKMARKS: {
        let quantity = MigrationUtils.getImportedCount("bookmarks");
        let stringID = "migration-wizard-progress-success-bookmarks";

        if (
          lazy.MigrationWizardConstants.USES_FAVORITES.includes(migratorKey)
        ) {
          stringID = "migration-wizard-progress-success-favorites";
        }

        return lazy.gFluentStrings.formatValue(stringID, {
          quantity,
        });
      }
      case lazy.MigrationWizardConstants.DISPLAYED_RESOURCE_TYPES.HISTORY: {
        return lazy.gFluentStrings.formatValue(
          "migration-wizard-progress-success-history",
          {
            maxAgeInDays: MigrationUtils.HISTORY_MAX_AGE_IN_DAYS,
          }
        );
      }
      case lazy.MigrationWizardConstants.DISPLAYED_RESOURCE_TYPES.PASSWORDS: {
        let quantity = MigrationUtils.getImportedCount("logins");
        return lazy.gFluentStrings.formatValue(
          "migration-wizard-progress-success-passwords",
          {
            quantity,
          }
        );
      }
      case lazy.MigrationWizardConstants.DISPLAYED_RESOURCE_TYPES.FORMDATA: {
        return lazy.gFluentStrings.formatValue(
          "migration-wizard-progress-success-formdata"
        );
      }
      case lazy.MigrationWizardConstants.DISPLAYED_RESOURCE_TYPES
        .PAYMENT_METHODS: {
        let quantity = MigrationUtils.getImportedCount("cards");
        return lazy.gFluentStrings.formatValue(
          "migration-wizard-progress-success-payment-methods",
          {
            quantity,
          }
        );
      }
      default: {
        return "";
      }
    }
  }
  */

  /*
   * @param {FileMigrator} fileMigrator
   * @returns {Promise<object|null>}
   */

  /*
  async #serializeFileMigrator(fileMigrator) {
    if (!fileMigrator.enabled) {
      return null;
    }

    return {
      type: lazy.MigrationWizardConstants.MIGRATOR_TYPES.FILE,
      key: fileMigrator.constructor.key,
      displayName: await lazy.gFluentStrings.formatValue(
        fileMigrator.constructor.displayNameL10nID
      ),
      brandImage: fileMigrator.constructor.brandImage,
      resourceTypes: [],
    };
  }
}
*/
